%%% ZAVOD GYMNASTEK
% V kazde ze ctyr disciplin zvitezila jina zavodnice.
% Urcete jmena vitezek disciplin z techto informaci:
% Dvorakova ani Sobotkova nevyhraly preskok ani bradla.
% V preskoku nezvitezila Vera ani Ludmila.
% Sobotkova se nejmenuje ani Vera ani Jirina a kamaradi s Beckovou.
% Junkova neni ani Monika ani Jirina.
% Vera nevyhrala na bradlech, Monika nevyhrala v prostnych.
% Jednou z disciplin byla kladina.

%%%%%%% reseni permutacemi
	%vypise seznam jmen a seznam prijmeni vitezu soutezi v poradi:
    %vitezka Bradel, vitezka Kladiny, vitezka Preskoku, vitezka Prostnych

perm([], []).
perm(L, [X | P]) :- del(X, L, L1), perm(L1, P).

del(X, [X | T], T).
del(X, [Y | T], [Y | T1]) :- del(X, T, T1).		

poradi(E, [E | _], 1) :- !. %hleda poradove cislo N, prvku E, v zadanem seznamu
poradi(E, [_ | T], N) :- poradi(E, T, M), N is M + 1.


vitez :- perm([jirina, ludmila, monika, vera], J),
         perm([beckova, dvorakova, junkova, sobotkova], P),
         J = [J1, _, J3, J4],
         P = [P1, _, P3, _],
         P1 \= dvorakova,        % Dvorakova nevyhrala bradla
         P1 \= sobotkova,        % Sobotkova nevyhrala bradla 
         P3 \= dvorakova,        % Dvorakova nevyhrala preskok 
         P3 \= sobotkova,        % Sobotkova nevyhrala preskok
         J3 \= vera,             % Vera nevyhrala preskok
         J3 \= ludmila,          % Ludmila nevyhrala preskok
         J1 \= vera,             % Verna nevyhrala bradla
         J4 \= monika,           % Monika nevyhrala prostna         
         poradi(sobotkova, P, N1), 
         poradi(vera, J, N2),
         poradi(jirina, J, N3),
         N1 \= N2,               % Sobotkova se nejmenuje Vera
         N1 \= N3,               % Sobotkova se nejmenuje Jirina         
         poradi(junkova, P, N4),
         poradi(monika, J, N5),
         N4 \= N5,               % Junkova se nejmenuje Monika
         N4 \= N3,               % Junkova se nejmenuje Jirina
         write(J), write(P).
